      subroutine x_scale(mscale) 
      use glbconst, only: max8,nwr
      use comdat, only: b_data,mxpt
      use comthe, only: real_fr
      implicit none 
                                                                        
      integer       mscale,nexp,nthe,k,i 
      real          x_exp,xb_exp,dx_exp,xb_the,dx_the,x 
      common/ascale/x_exp(max8),nexp,xb_exp,dx_exp,nthe,xb_the,dx_the 
                                                                        
      if(.not.b_data) then 
       if(mscale.eq.2) then 
        write(nwr,'(a)')' **warning** scale=2 requires data; set to 1' 
        mscale=1 
       end if 
      end if 
                                                                        
      goto (100,200,1000),mscale 
                                                                        
  100 continue 
!     scale of experimental points                                      
      x=xb_exp-dx_exp 
      do k=1,nexp 
       x=x+dx_exp 
       x_exp(k)=x 
      end do 
      goto 1000 
                                                                        
  200 continue 
!     scale of experimental points                                      
!     data for time or angle array taken from data file                 
      do i=1,nexp 
       x_exp(i)=real_fr(mxpt+i) 
      end do 
                                                                        
 1000  continue 
      return 
      END                                           
                                                                        
                                                                        
                                                                        
                                                                        
      subroutine data2dread(n1,info) 
      use glbconst, only: MDBPLFT,infotext
      use comdat, only: cdata_str,data_str,nuofdatas,nchannelsp,readform
      use comthe, only: nstorFR,real_fr,iarray_sp
      implicit none 
                                                                        
      integer,intent(in) :: n1
      integer,intent(out):: info
      character(len=132):: ch132,cp132
                                
      character(len=4), dimension(1:8) :: dacom
      integer,dimension(1:8) :: ldacom,iplace,iextra
      integer,dimension(1:16):: irow 
      real,   dimension(1:32):: out

      real        array,h 
      common/plot/array(MDBPLFT*2) 
!      equivalence (array(1),b_dat(1))                                  
      integer      i,ip,ipos,ir,ifound,ih,j,j1,jj1,jj2,k,nt,nj,irn 
                                                                        
!     write(6,'(a,5i7)') '  iarray_sp,nstorFR=',iarray_sp,nstorFR       
!     only even number of channels are handled                          
!      write(6,'(a,i4,2x,a)')'dataread n1,readform=',                   
!     &  n1,readform                                                    
                                                                        
      do k=1,8 
       ldacom(k)=0 
       iplace(k)=0 
       iextra(k)=0 
      end do 
                                                                        
      ip=1 
      ih=0 
      nt=0 
!      write(6,'(2a)')'cdata_str=', cdata_str    ! from data file       
      ch132=cdata_str 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nt=nt+1 
!      write(6,'(i5,2x,a)') ip,cp132(1:24)                              
                                                                        
       if(nt.eq.8.or.ip.eq.0)then 
        ip=0 
        dacom(nt)=' ' 
        ldacom(nt)=ip 
       else 
        dacom(nt)=cp132(1:ip) 
        ldacom(nt)=ip 
        end if 
       end do 
       nt=nt-1 
!      write(6,'(a,10a6)') ' dacom=',(dacom(i),i=1,nt)                  
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,nt)                
                                                                        
!      write(6,'(2a)') 'from th data_str=',data_str            ! from fr
      ch132=data_str 
      ip=1 
      ih=0 
      ir=0 
      nj=0 
      do while(ip.gt.0) 
       call nextchar(ch132,ih,ipos,cp132,ip) 
       ch132=cp132 
       ih=ip 
       nj=nj+1 
       ifound=10 
       if(nj.eq.8) ip=0 
       if(ip.gt.0) then 
        ifound=0 
!       write(6,'(i5,2x,a)') ip,cp132(1:24)                             
        do k=1,nt 
!        write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' dacom(k)=',               
!     &                   dacom(k),cp132(1:ip)                          
         if(cp132(1:ip).eq.dacom(k)) then 
          ir=ir+1 
          iplace(ir)=k 
          ifound=1 
         end if 
        end do 
       end if 
       if(ifound.eq.0) then 
        do k=1,nt 
         if(cp132(1:1).eq.'d'.and.cp132(2:2).eq.dacom(k)) then 
!         write(6,'(a,i2,a,a4,2x,a)') 'found=0 k=',k,                   
!     &   ' dacom(k)=',dacom(k),cp132(1:2)                              
          iextra(ir)=k 
          ifound=1 
         end if 
!        write(6,'(a,2i5)') 'k,ifound=',k,ifound                        
        end do 
       end if 
       if(ifound.eq.0) then 
        info=23 
        infotext(1)='effi/data/read_data/format' 
        infotext(3)='expected data format not on data file' 
        infotext(4)='format: '//cdata_str(:12)//'expected format: '     &
     &    //data_str                                                    
        infotext(5)=' ' 
        goto 250 
       end if 
      end do 
!      write(6,'(a,i4)')   ' return, ifound=',ifound                    
!      write(6,'(a,10i5)') ' ldacom=',(ldacom(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iplace=',(iplace(i),i=1,8)                 
!      write(6,'(a,10i5)') ' iextra=',(iextra(i),i=1,8)                 
                                                                        
!     reading of data type n=1,2,...,8                                  
!     storing data of type istortype=1...8                              
      ip=-1 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=j1+ip*nchannelsp 
       if(iextra(k).gt.0) then 
        ip=ip+1 
       end if 
      end do 
!      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp             
      nuofdatas=(ip+1)*int((nchannelsp+1)/2) 
!      write(6,'(a,6i6)') ' nuofdatas=',nuofdatas                       
      if(n1.eq.0) return 
                                                                        
      k=nchannelsp*nt 
!     write(6,'(a,6i6)') ' n1,nt,k,nchannelsp=',n1,nt,k,nchannelsp      
      i=index(readform,'free') 
      if(i.gt.0)then 
       ch132=readform(2:i) 
       call trlch(i+1,ch132,irn,out) 
       do i=1,irn 
        irow(i)=out(i) 
       end do 
                                                                        
       j=0 
       do while(j.lt.k) 
        read(n1,'(a)',end=50,err=240)ch132 
        call trlch(80,ch132,ipos,out) 
        do ip=1,irn 
         array(ip+j)=out(irow(ip)) 
        end do 
        j=j+irn 
       end do 
      else 
!      write(6,'(a,a)') ' readform=',readform                           
       read(n1,readform,end=50,err=240) (array(i),i=1,k) 
      end if 
      goto 60 
   50 info=25 
      infotext(3)='read found EOF' 
      infotext(4)=' ' 
      goto 250 
   60 continue 
                                                                        
      ip=-1 
      j1=2*(iarray_sp+nstorFR) 
      do k=1,ir 
       j=nt-iplace(k) 
       ip=ip+1 
       jj1=j1+ip*nchannelsp 
!       write(6,'(a,6i7)') ' ir,iplace(k),nt,j,jj1,iextra(k)=',         
!     &                 ir,iplace(k),nt,j,jj1,iextra(k)                 
       do i=1,nchannelsp 
        real_fr(jj1+i)=array(nt*i-j) 
       end do 
                                                                        
!       write(6,'(8f10.2)')(real_fr(jj1+i),i=1,8)                       
       if(iextra(k).gt.0) then 
        ip=ip+1 
        jj2=j1+ip*nchannelsp 
!       write(6,'(a,6i7)') ' ip,iplace(k),nt,j,jj2=',                   
!     &                 ip,iplace(k),nt,j,jj2                           
        do i=1,nchannelsp 
         h=real_fr(jj1+i) 
         if(h.gt.0) then 
          real_fr(jj2+i)=sqrt(h) 
         else 
          real_fr(jj2+i)=1. 
         end if 
        end do 
       end if 
      end do 
!      write(6,'(a,6i6)') 'cc ip,nchannelsp=',ip,nchannelsp             
                                                                        
      goto 250 
  240 continue 
!     read error format?                                                
      info=24 
      infotext(3)='read error of data file, identified format:' 
      infotext(4)=readform 
      infotext(5)=' ' 
  250 continue 
      return 
      END                                           
                                                                        
     subroutine punch2d(nout,info) 
     use glbconst, only: maxn,max8,maxsub,MDBPLFT,mplot,infplot,nwr
     implicit none
                                                                 
     integer,intent(in) :: nout
     integer,intent(out):: info
     integer,parameter:: max8subn=maxsub*max8,maxn6=max8*6,            &
                         idumpl=MDBPLFT*2-140*maxn-8*39-maxsub-        &
                         5*infplot-120  
     character(len=132):: ch132,cp132,cpunch,title,plotstrpu,iform,    &
                          cpunchsu,cpunchw,cpunchstrj
     character(len=80) :: plotstrdef     
     character(len=40) :: stringnumber
     character(len=24) :: axesname
     character(len=16) :: axisformat
     character(len=8)  :: kform
     character(len=4)  :: namechan,chdum
     character(len=2)  :: su

     integer     ifeder,ltext,int3d,npnt3d,ncolor,                     &
                 npntplot,nchanplot,n_subspectra,logx,logy,logf
     real        plotarray,xyzdz,vtxt,vtxtp 
     common/plot/plotarray(maxn6+max8subn),                            &
                 xyzdz(8),vtxt(2,maxn*4),vtxtp(8,32),                  &
                 int3d(maxn*16),npnt3d(16),ifeder(4*maxn),ltext(32),   &
                 npntplot(infplot),nchanplot(infplot),ncolor(maxsub),  &
                 n_subspectra,logx,logy,logf,                          &
                 namechan(infplot),kform(infplot),axisformat(3),       &
                 axesname(3),title,plotstrdef,plotstrpu,               &
                 chdum(idumpl)                                         

     character(len=8) ,dimension(1:2*infplot):: k2form
     integer,dimension(1:infplot):: iplace,lname,jp
     integer,dimension(maxsub):: npanum
     integer   i,if,ifound,ih,ii,il,ip,ip1,ipk,ipos,ipw,k,l,jka,jkz,   &
               ir,isu,lfr,lpw,nch,nsequence                                                                  
      info=0
      k=1 
      do while(kform(k).ne.' '.and.k.lt.infplot) 
       k2form(k)=kform(k) 
!       write(6,'(a)')kform(k)                                          
       k=k+1 
      end do 
      k=k-1 
      do i=1,k 
       k2form(k+i)=kform(k) 
      end do 
                                                                        
                                                                        
!      do ii=1,infplotarray*2                                           
!       scratch(ii)=plotarray(ii)                                       
!      end do                                                           
      do k=1,infplot 
       l=index(namechan(k),' ') 
       lname(k)=l-1 
       if(lname(k).le.0) lname(k)=4 
      end do 
                                                                        
      cpunch=plotstrpu 
      l=LEN_TRIM(cpunch) 
      do k=1,l 
       if(cpunch(k:k).eq.',')cpunch(k:k)=' ' 
      end do 
      nsequence=1 
  100 continue 
!      write(6,'(2a)') 'print  100:',cpunch(1:60)                       
      jka=index(cpunch,'(') 
      jkz=index(cpunch,')') 
      cpunchstrj=' ' 
      if(jka.gt.0.and.jkz.gt.0) then 
       cpunchstrj=cpunch(jka:jkz) 
       if(jka.gt.1)then 
        if(cpunch(jka-1:jka-1).eq.'d')cpunchstrj='d'//cpunch(jka:jkz) 
       end if 
       nsequence=0 
       cpunchw=cpunch(jka+1:jkz-1) 
       cp132=cpunch(jkz+1:) 
       cpunch=cp132 
      else 
       cpunchstrj=cpunch 
       cpunchw=cpunch 
       cpunch=' ' 
      end if 
                                                                        
      do k=1,8 
       iplace(k)=0 
      end do 
                                                                        
      su=namechan(mplot+1) 
!     write(6,'(3a)')'namechan(mplot+1)=',namechan(mplot+1)             
      ir=0 
                                                                        
  200 continue 
!      write(6,'(3a)') ' 200: cpunchw=',cpunchw(1:30)                   
      isu=index(cpunchw,su) 
      if(isu.gt.0) then 
       ch132=cpunchw(1:isu-1) 
       cp132=cpunchw(isu:) 
       cpunchw=cp132 
!       write(6,'(3a)') 'isu.gt.0: cpunchw=',cpunchw(1:30)              
       ipw=0 
       k=1 
       do while(k.le.mplot.and.ipw.eq.0) 
        ipw=index(cpunchw,namechan(k)(1:lname(k))) 
!       write(6,'(i4,3a)') ipw,'=ipw: cpunchw,namechan(k)=',            
!     &       cpunchw(1:30),namechan(k)(1:lname(k))                     
        k=k+1 
       end do 
       if(ipw.gt.0) then 
        cp132=cpunchw(ipw:) 
        cpunchsu=cpunchw(1:ipw-1) 
        cpunchw=cp132 
!        write(6,'(3a)') 'ipw.gt.0: cpunchw,cpunchsu=',                 
!     &    cpunchw(1:30),cpunchsu(1:30)                                 
       else 
        cpunchsu=cpunchw 
        cpunchw=' ' 
!       write(6,'(3a)') 'ipw.eq.0: cpunchw,cpunchsu=',                  
!     &    cpunchw(1:30),cpunchsu(1:30)                                 
       end if 
      else 
       ch132=cpunchw 
!      write(6,'(3a)') 'isu.eq.0: cpunchw=',cpunchw(1:30)               
       cpunchsu=' ' 
       cpunchw=' ' 
      end if 
                                                                        
      ifound=0 
      ip=1 
      ih=0 
  210 continue 
      call nextchar(ch132,ih,ipos,cp132,ip) 
      ch132=cp132 
      ih=ip 
!      write(6,'(a,i5,2x,a)') 'ip,cp132(1:24)=',ip,cp132(1:24)          
      if(ip.gt.0) then 
       do k=1,infplot 
!       k=0                                                             
!       do while(ifound.eq.0.and.k.lt.infplot)                          
!        k=k+1                                                          
!        write(6,'(i4,a,i2,a,a4,2x,a)') ifound,' k=',k,' namechan(k)=',& 
!               namechan(k)(1:lname(k)),cp132(1:ip)                    
        if(namechan(k)(1:lname(k)).eq.cp132(1:ip)) then 
!         write(6,'(a,i2,a,a4,2x,a)') 'k=',k,' namechan(k)=', &          
!                        namechan(k),cp132(1:ip)                       
!          write(6,'(a)') cpunchw(1:80)                                 
         ir=ir+1 
         iplace(ir)=k 
         ifound=1 
        end if 
       end do 
!       write(6,'(a,10i4)') ' ir,ifound=',ir,ifound                     
       if(ifound.eq.0) then 
        write(nwr,'(3a)')                                               &
              '**error** ',cp132(1:ip),' is not a data type'           
       end if 
       goto 210 
      end if 
!      write(6,'(a)') cpunchsu(1:80)                                    
      nch=132 
      isu=index(cpunchsu,'su') 
      if(isu.gt.0) cpunchsu(isu:isu+1)=' ' 
      call panum(cpunchsu,n_subspectra,npanum,1) 
!      write(6,'(a,10i4)') ' npanum=',(npanum(i),i=1,10)                
!      write(6,'(a,10i4)') ' ir,mplot=',ir,mplot                        
      do k=1,npanum(2) 
       iplace(ir+k)=mplot+npanum(2+k) 
      end do 
      ir=ir+npanum(2) 
!      write(6,'(2a)') 'cpunchw=',cpunchw(1:60)                         
      if(cpunchw.ne.' ') goto 200 
                                                                        
      if(ir.eq.0) goto 1000 
      write(nout,'(a)') TRIM(title) 
                                                                        
!       write(6,'(a,20i3)') ' nseq=0,iplace=',(iplace(i),i=1,ir)        
        ipk=iplace(1)
        ch132=k2form(ipk)
        il=LEN_TRIM(ch132)
        iform='('//ch132(1:il)
        if=il+1 
        do k=2,ir 
         ipk=iplace(k) 
         ch132=k2form(ipk) 
!        write(6,'(a,2x,a)') 'ipk,k2form',ipk,k2form(ipk)               
         il=LEN_TRIM(ch132)
         iform(if+1:if+1+il)=','//ch132(1:il) 
         if=if+1+il 
        end do 
        iform(if+1:if+1)=')' 
        lfr=if+1 
        write(nout,'(a,2x,a)') iform(:lfr),TRIM(cpunchstrj)
        write(nwr,'(17x,a,2x,a)') iform(:lfr),TRIM(cpunchstrj)

        ip1=iplace(1) 
        write(unit=stringnumber,fmt=300)nchanplot(ip1)
 300    format ('nu_channels=',i5)
        write(nout,'(a)') stringnumber 
                                                                        
        do k=1,ir 
         jp(k)=(iplace(k)-1)*max8 
!        write(6,'(a,3i5,2x,f15.6)') ' ir,iplace(k),j,plotarray(j+1)=', 
!     &                 ir,iplace(k),jp(k),plotarray(jp(k)+1)-1.        
        end do 
        do i=1,nchanplot(iplace(1)) 
         write(nout,iform) (plotarray(jp(k)+i),k=1,ir) 
        end do 
        write(nout,'(a)') (axesname(i),i=1,3) 
       if(cpunch.ne.' ') goto 100 
 1000  continue 
      write(nout,'(a2)')'##' 
      return 
      END                                           
                                                                        
      subroutine testplot
      use glbconst, only:  MDBPLFT
      integer  idum 
      common/plot/ idum(MDBPLFT*2) 
      return 
      END                                           
